using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Configuration;
using System.Threading;
using WebSupergoo.ABCpdf7;
using WebSupergoo.ABCpdf7.Objects;
using System.Linq;
using System.Xml.Linq;
using System.Xml;



namespace ConvertPdfToText


{
    //using uint = UInt32;
    using CONVERT = System.Convert;
    public partial class ConvertPdfForm : Form
    {
        //GflAxClass m_objGFl;
        int m_nRegionGrowingParameter;
        double m_dPrecision;
        short m_nMinWidth;
        short m_nMinHeight;
        int m_nMaxLight;
        int m_nCommonFilesNumber;
        int m_nCornerThreshold;
        bool m_bIsTestMode;
        bool m_bIsBW;
        bool m_bIsColorArtifact;
        string m_strArtifactFolder;
        int m_nRateMaxSize;
        int m_nAverageeight;
        int m_nAverageWidth;
        int m_nProcent;
        int m_nQuality;

        int m_nEdgeLimit;
        bool m_bIsLightRegionMerge;
        bool m_bIsTestSymbolOnBound;
        bool m_bLogging;
        int m_nRectLimit;
        int m_nTimeOut;
        short m_nMergeWidth;
        short m_nMergeHeight;



        private System.ComponentModel.BackgroundWorker backgroundWorkerCard;
        private void InitializeBackgoundWorker()
        {
            this.m_numpat.Text="";
            this.m_ncp.Text="";

            this.backgroundWorkerCard = new System.ComponentModel.BackgroundWorker();
            this.backgroundWorkerCard.WorkerReportsProgress = true;
            this.backgroundWorkerCard.WorkerSupportsCancellation = true;

            backgroundWorkerCard.DoWork +=
                new DoWorkEventHandler(backgroundWorkerCard_DoWork);

            backgroundWorkerCard.RunWorkerCompleted +=
                new RunWorkerCompletedEventHandler(
            backgroundWorkerCard_RunWorkerCompleted);

            backgroundWorkerCard.ProgressChanged +=
                new ProgressChangedEventHandler(
            backgroundWorkerCard_ProgressChanged);
        }
        // background operation.
        private void backgroundWorkerCard_DoWork(object sender,
          DoWorkEventArgs e)
        {
            // Get the BackgroundWorker that raised this event.
            BackgroundWorker worker = sender as BackgroundWorker;

            // Assign the result of the computation
            // to the Result property of the DoWorkEventArgs
            // object. This is will be available to the 
            // RunWorkerCompleted eventhandler.
           // e.Result = Compute((int)e.Argument, worker, e);
            e.Result = Compute(worker);
        }

        private void backgroundWorkerCard_RunWorkerCompleted(
            object sender, RunWorkerCompletedEventArgs e)
        {
            this.m_btnExecute.Enabled = true;
        }

        // This event handler updates the progress bar.
        private void backgroundWorkerCard_ProgressChanged(object sender,
            ProgressChangedEventArgs e)
        {
            this.m_progressBar.Increment(1);
            int nc = System.Convert.ToInt32(m_ncp.Text)+1;
            m_ncp.Text=nc.ToString();
            //this. = e.ProgressPercentage;
        }

        public ConvertPdfForm()
        {
            InitializeComponent();
            InitializeBackgoundWorker();
          








          
         

        }

        private void m_btChIn_Click(object sender, EventArgs e)
        {
            if (m_InputFolderDialog.ShowDialog() == DialogResult.OK)
            {
                m_edtInputFolder.Text = m_InputFolderDialog.SelectedPath;

                DirectoryInfo dirInput = new DirectoryInfo(m_edtInputFolder.Text);

                try
                {
                    if (!dirInput.Exists)
                        dirInput.Create();
                }
                catch (Exception ex1)
                {
                    string str = "Folder " + m_edtInputFolder.Text + "can not be created!";
                    MessageBox.Show("The calculations are complete", str,
                    MessageBoxButtons.OK, MessageBoxIcon.Asterisk);

                }


                if (m_edtOutputFolder.Text != null && m_edtInputFolder.Text != null)
                {
                    m_btnExecute.Enabled = true;
                    m_progressBar.Visible = false;
                    m_progressBar.Enabled = false;
                    m_progressBar.Value = 0;
                }
            }

        }

        private void m_btnChOutput_Click(object sender, EventArgs e)
        {
            if (m_OutputFolderDialog.ShowDialog() == DialogResult.OK)
            {
                m_edtOutputFolder.Text = m_OutputFolderDialog.SelectedPath;




                if (m_edtOutputFolder.Text != null && m_edtInputFolder.Text != null)
                {
                    m_btnExecute.Enabled = true;
                    m_progressBar.Visible = false;
                    m_progressBar.Enabled = false;
                    m_progressBar.Value = 0;

                }

            }
        }
        private int DeleteEmptyDirectory(string strInitDirectory)
        {
            DirectoryInfo dirInput = new DirectoryInfo(strInitDirectory);

            FileSystemInfo[] objDirSytemInfo = dirInput.GetDirectories();


            FileSystemInfo[] objFileSytemInfo = dirInput.GetFiles();


            int nFileNumber = objFileSytemInfo.Length;



            foreach (DirectoryInfo objFSI in objDirSytemInfo)
            {
                string strSubDirectory = strInitDirectory + "\\" + objFSI.Name;

                int nFileInDirectory = CalculateFileNumber(strSubDirectory);
                if (nFileInDirectory == 0)
                    Directory.Delete(strSubDirectory);


            }
            return nFileNumber;
        }
        private int CalculateFileNumber(string strInitDirectory)
        {
            DirectoryInfo dirInput = new DirectoryInfo(strInitDirectory);
          
            FileSystemInfo[] objDirSytemInfo = dirInput.GetDirectories();


            FileSystemInfo[] objFileSytemInfo = dirInput.GetFiles();
          

            int nFileName = objFileSytemInfo.Length;

           

            foreach (DirectoryInfo objFSI in objDirSytemInfo)
            {
                string strSubDirectory = strInitDirectory + "\\" + objFSI.Name;

                nFileName += CalculateFileNumber(strSubDirectory);
               

            }
            return nFileName;
        }
        private void AnalyzeDirectory(BackgroundWorker worker,string strInitDirectory,string strOutDirectory,string  strArtifactDirectory,bool bInit)
        {
            /*
            string[] strDirectory = Directory.GetDirectories(strInitDirectory);
            string[] strFiles = Directory.GetDirectories(strInitDirectory);
           



          foreach (string str in strFiles)
          {
              string strFullName = strInitDirectory+"//"+str;
              SendToOuputFolder(strFullName, str, strOutDirectory, strArtifactDirectory);
              worker.ReportProgress(1);


          }

          foreach (string str in strDirectory)
          {
              string strSubDirectory = strOutDirectory + "\\" + str;
              string strArtifactSubDirectory = strArtifactDirectory + "\\" + str;

              Directory.CreateDirectory(strSubDirectory);
              Directory.CreateDirectory(strArtifactSubDirectory);
              string strFullName = strInitDirectory + "//" + str;

              AnalyzeDirectory(worker, strFullName, strSubDirectory, strArtifactSubDirectory, false);





          }
          strDirectory = null;
          strFiles = null;
            */

          
          DirectoryInfo dirInput = new DirectoryInfo(strInitDirectory);


          FileSystemInfo[] objFileSytemInfo = dirInput.GetFiles();
          FileSystemInfo[] objDirSytemInfo = dirInput.GetDirectories();
            if (objFileSytemInfo.Length > 0)
            {
                foreach (FileSystemInfo objFSI in objFileSytemInfo)
                {

                    SendToOuputFolder(objFSI.FullName, objFSI.Name, strOutDirectory, strArtifactDirectory);
                    worker.ReportProgress(1);
                   

                }
                
             }

            foreach (DirectoryInfo objFSI in objDirSytemInfo)
            {
                string strSubDirectory = strOutDirectory + "\\" + objFSI.Name;
                string strArtifactSubDirectory = strArtifactDirectory + "\\" + objFSI.Name;
               
                Directory.CreateDirectory(strSubDirectory);
                Directory.CreateDirectory(strArtifactSubDirectory);

                AnalyzeDirectory(worker,objFSI.FullName, strSubDirectory, strArtifactSubDirectory,false);
               

               
                

            }
           

        }
        private void m_btnExecute_Click(object sender, EventArgs e)


        {
            DirectoryInfo dirInput = new DirectoryInfo(m_edtInputFolder.Text);

           
            
                if (!dirInput.Exists)
                
            
                {
                   string str = " " + m_edtInputFolder.Text + "  !";
                   MessageBox.Show(" ", str,
                   MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                   m_btnExecute.Enabled = false;
                   return;

               }

            DirectoryInfo dirOutput = new DirectoryInfo(m_edtOutputFolder.Text);

            try
            {
                if (!dirOutput.Exists)
                    dirOutput.Create();
            }
            catch (System.IO.IOException ex1)
            {
                string str = "Folder " + m_edtOutputFolder.Text + " can not be created!";
                MessageBox.Show(str,"Opearator error",
                MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                m_btnExecute.Enabled = false;
                return;

            }
            DirectoryInfo dirOutputCheck = new DirectoryInfo(m_edtOutputFolder.Text);

            if (!dirOutputCheck.Exists)
            {


                string str = "Folder " + m_edtOutputFolder.Text + "    !";
                MessageBox.Show(str," ",
                MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                m_btnExecute.Enabled = false;
                return;


            }




            m_progressBar.Visible = true;
            m_progressBar.Enabled = true;
            m_nCommonFilesNumber=CalculateFileNumber(m_edtInputFolder.Text);
            this.m_numpat.Text = m_nCommonFilesNumber.ToString();
            int initn = 0;
            this.m_ncp.Text = initn.ToString();

            m_progressBar.Value = 0;
            m_progressBar.Maximum = m_nCommonFilesNumber;
            m_progressBar.Minimum = 0;
            
            backgroundWorkerCard.RunWorkerAsync();// (numberToCompute);
           // Thread WorkThread = new Thread(Compute);
            //WorkThread.Start(5);
          //  ThreadPool.QueueUserWorkItem(Compute, 5);
           // AnalyzeDirectory(m_edtInputFolder.Text, m_edtOutputFolder.Text,m_strArtifactFolder, true);
            //DeleteEmptyDirectory(m_strArtifactFolder);
            m_btnExecute.Enabled = false;





        }
      //  private long Compute(int n, BackgroundWorker worker, DoWorkEventArgs e)
        private long Compute(BackgroundWorker worker)
        {
            AnalyzeDirectory(worker, m_edtInputFolder.Text, m_edtOutputFolder.Text, m_strArtifactFolder, true);

            return 0;

        }
        private void SendToOuputFolder(string strInputFileName, string strShortName, string strOutDirectory, string strArtifactDirectory)
        {
          

            //string strDastrInputFileName.Split("/");

            string strOutputFileName = strOutDirectory + "\\" + strShortName;
            string strArtifactName = strArtifactDirectory + "\\" + strShortName;

            

            CardCorrecting(strInputFileName, strOutputFileName,strArtifactName);
        


            

        }
        
        private void CardCorrecting(string strFileName,string stroutputFileName,string strArtifactName)
        {


            string strdir = Path.GetDirectoryName(stroutputFileName);
            string strname = Path.GetFileNameWithoutExtension(stroutputFileName);
            string outputFileName = null;
            Doc doc = new Doc();
            doc.Read(strFileName);
          //  Text = "Content Extract - " + strFileName;
            string textMode=Properties.Settings.Default.TextMode;
            if (textMode == "Txt")
            {
                outputFileName = Path.Combine(strdir, strname + ".txt");
                TextWrite(outputFileName, doc);

            }
            if (textMode == "SVG")
            {
                outputFileName = Path.Combine(strdir, strname + ".pdf");
                PdfWrite(outputFileName, doc);

            }
   
   

        }
    void TextWrite(string outputFileName,Doc doc)
    {
         FileInfo f = new FileInfo(outputFileName);
            
            StreamWriter objWriter = f.CreateText();
            
            

			
			int count = doc.PageCount;
			
            for (int i = 0; i < count; ++i)
            {
                doc.PageNumber = i;
                string strText = doc.GetText("Text");
                objWriter.Write(strText);

                objWriter.Write("\v\r\n");
                int ij = 0;

            }

            objWriter.Close();
    }
    void PdfWrite(string outputFileName, Doc doc)
    {

        int count = doc.PageCount;

        for (int i = 0; i < count; ++i)
        {
            doc.PageNumber = i;
            string strText = doc.GetText("SVG");
            XDocument xd = XDocument.Parse(strText);
            var atr=xd.Elements().Attributes();
          //  int nwidth=System.Convert.ToInt32(xd.Element("svg").Attributes("width"));
           // int nheight=System.Convert.ToInt32(xd.Element("svg").Attributes("height"));
          //  int x=System.Convert.ToInt32(xd.Element("svg").Attributes("x"));
          //  int y=System.Convert.ToInt32(xd.Element("svg").Attributes("y"));
            IEnumerable<XElement> texts = xd.Elements().Descendants();
            xd.Save(outputFileName);
            foreach (XElement x in texts)
            {
                

                if (x.Name.LocalName == "text")
                {
                    var at = x.Attributes();
                    string val=x.Value;
                    int l = 0;
                }



            }
            /*
                        select new
                        {
                            x = text.Attributes("x"),
                            y = text.Attributes("y"),
                            fontSize = text.Attributes("font-size"),
                            fontFamily = text.Attributes("font-family"),
                            t = text.Value
                        };
             */
            int ik=0;

        }
    }
       
        private void m_edtInputFolder_TextChanged(object sender, EventArgs e)

        {

            if (m_edtOutputFolder.Text != null && m_edtInputFolder.Text != null)
            {
                m_btnExecute.Enabled = true;
                m_progressBar.Visible = false;
                m_progressBar.Enabled = false;
                m_progressBar.Value = 0;
            }
           
        }

        private void m_gbExecute_Enter(object sender, EventArgs e)
        {

        }
    }
}